#inputs: d, h, sx, sy, sym, mips
BEGIN {
	lastok = 0;
}
{
	if ($2==d && $4==h && NF>=6) {
		n[$1]+=1
		s[$1]+=$6
		sq[$1]+=$6*$6;
	}
}
END {
for (node=30; node<=90; node+=10) {
	if (n[node]==5) {
		av=s[node]/n[node];
		sd=sqrt((sq[node]+n[node]*av*av-2*av*s[node])/(n[node]-1))

		x = node*sx;
		y = log(av*mips/1000)*sy;
		print "\\put("x","y"){\\makebox(0,0){"sym"}}%"
		if (lastok) {
			dx = x-lastx;
			dy = y-lasty;
			dist = int(sqrt(dx*dx+dy*dy)+.5);
			stepx=dx/dist;
			stepy=dy/dist;
				lastx = lastx+4*stepx/2;
				lasty = lasty+4*stepy/2;
			for (i=1+4; i<dist; i++) {
				lastx = lastx+stepx;
				lasty = lasty+stepy;
				print "\\put("lastx", "lasty"){\\makebox(0,0){$\\cdot$}}%";
			}
	#		print "\\multiput("lastx+stepx", "lasty+stepy")("stepx","stepy"){"dist-1"}{\\makebox(0,0){$\\cdot$}}%";
		}
		lastok = 1; lastx = x; lasty = y;
	} else
		lastok = 0;
}
}