%this one is taken from the clp(r) manual

top:-
	read(N,[]),
	cputime(T0),
	goal(N),
	cputime(T1),
	Time is T1-T0,
	write((time=Time,p(N,L))),nl.


goal:- eq([_,_,_,_],L), order(L), select(L). %write(L), nl.% , fail.

goal(0).
goal(N):- N1 is N-1, goal, goal(N1).

eq(X,X).
elem(34).
elem(12).
elem(45).
elem(91).
elem(2).
elem(3).

order([H1,H2|T]):- less(H1,H2), order([H2|T]).
order([E]).

delay less(nonvar,nonvar).
less(X,Y):- X<Y.

select([H|T]):- elem(H), select(T).
select([]).
