% delays many plus's, instantiates their first arguments, then the second one
% tests speed of wakeup and redelay of plus/3.
% systems that make the second and the third argument responsible
% should be faster on this one

top:-
	read(N,[]),
	cputime(T0),
	goal(N,X,Y),
	X=1, Y=1,
	cputime(T1),
	Time is T1-T0,
	write((time=Time,r(N,X,Y))),nl.

goal(0,_,_).
goal(N,X,Y):- N>0, N1 is N-1, plus(X,Y,Z), goal(N1,X,Y).

X=X.
