%prime numbers from clocksin & mellish

top:-
	read(N,[]),
	cputime(T0),
	primes(N,X),
	cputime(T1),
	Time is T1-T0,
	write((time=Time,primes(N,X))),nl.

primes(Limit,Ps):- integers(2,Limit, Is), sift(Is,Ps).

%delay integers(nonvar,nonvar,any).
%delay integers(any,any,nonvar).
integers(Low,High,[]):- Low>High.
integers(Low,High,[Low|Rest]) :-
	Low < High+1,M is Low+1, integers(M,High,Rest).

%delay sift(nonvar,any).
%sift(X,Y):-write(sift(X,Y)),nl,fail.
sift([],[]).
sift([I|Is], [I|Ps]):- remove(I,Is,New), sift(New,Ps).

%delay remove(nonvar,nonvar,any).
remove(P,[],[]).
remove(P,[I|Is],[I|Nis]):- not(divides(P,I)),remove(P, Is,Nis).
remove(P,[I|Is],Nis):- divides(P,I), remove(P, Is, Nis).

%delay not(ground).
not(G):- call(G),!,fail.
not(G).

%delay divides(nonvar,nonvar).
divides(T,Z):- 0 is Z mod T.
