mincolor(L,N,M,H):-
	L in 1..M,
	graph(L),
	between1(N,1,M),	%assumption: between generates from lo to hi
	L in 1..N,
	labeling(L,H).

labeling(X,H):- labeling(X,0,H).

labeling([],Newup,_).
labeling([X|Y], Up, H):- 
	deleteff(Var, [X|Y], Rest,H),
	labelvar(Var, Up, Newup),
	labeling(Rest, Newup, H).

labelvar(X,N,N):- between(X,1,N).
labelvar(X,N,X):- X is N+1.

between1(X,X,H).
between1(X,L,H):- plus(L,1,L1), H>=L1, between1(X,L1,H).

between(X,L,H):- H >= L, [X] in L..H, indomain(X).
