%slowsort (taken from clocksin&mellish)
%with coroutining it becomes a O(2^n) algorithm

sort(L1,L2):- 
sorted(L2),
permutation(L1,L2).
%write(permutation(L1,L2)),

permutation([],[]).
permutation(L,[H|T]):-
	delete(H,L,R),
%	append(V,[H|U],L),
%	append(V,U,W),
	permutation(R,T).

delay sorted(nonvar).
sorted([]). %:-write(sorted([])),nl.
sorted([X|T]):-sorted(X,T). %,write(sorted([X|T])),nl.

delay sorted(any,nonvar).
sorted(X,[]). %:-write(sorted(X,[])),nl.
sorted(N, [H|T]):- order(N,H),sorted(H,T). %,write(sorted(N,[H|T])),nl.

%X=X.

delete(X,[X|Xs],Xs). %:- write(X=Y),nl,X=Y.
delete(X,[Y|Ys],[Y|Rs]):- delete(X,Ys,Rs).

append([],L,L).
append([A|X],Y,[A|Z]):- append(X,Y,Z).

delay order(nonvar,nonvar).
order(X,Y):- X<Y. %write(order(X,Y)),nl,X<Y.

top:-
	read(L1,[]),
	cputime(T0),
	sort(L1,L2),
	cputime(T1),
	Time is T1-T0,
	write((time=Time,sort(L1,L2))),nl.
