jobs(
[AA,AB,AC,AD,AE,AF,AG,
BA,BB,
CA,CB,CC,
DA,DB,DC,DD,
EA,EB,
FA,FB,
GA,GB,
HA,HB,HC,HD,HE,HF,HG,HH,
IA,IB,IC,ID,IE,IF,IG,IH],
Msgs,End):-

	task(AA,stim_aa,4,0),
	task(AB,ab,4,1),
	task(AC,ac,2,1),
	task(AD,ad,2,1),
	task(AE,ae,2,3),
	task(AF,af,4,0),
	task(AG,ag,6,2),
	task(BA,stim_ba,2,1),
	task(BB,bb,2,1),
	task(CA,stim_ca,8,0),
	task(CB,cb,14,0),
	task(CC,cc,4,1),
	task(DA,stim_da,2,2),
	task(DB,db,2,2),
	task(DC,dc,2,3),
	task(DD,dd,2,3),
	task(EA,stim_ea,2,3),
	task(EB,eb,2,2),
	task(FA,stim_fa,1,1),
	task(FB,fb,1,1),
	task(GA,stim_ga,1,1),
	task(GB,gb,2,3),
	task(HA,stim_ha,1,7),
	task(HB,hb,1,7),
	task(HC,hc,1,7),
	task(HD,hd,1,7),
	task(HE,he,1,5),
	task(HF,hf,1,5),
	task(HG,hg,1,5),
	task(HH,hh,1,5),
	task(IA,stim_ia,1,4),
	task(IB,ib,1,4),
	task(IC,ic,1,4),
	task(ID,id,1,4),
	task(IE,ie,1,6),
	task(IF,if,1,6),
	task(IG,ig,1,6),
	task(IH,ih,1,6),
write(tasks),nl,	
	period([AA,AB,AC,AD,AE,AF,AG],64),
	period([BA,BB],32),
	period([CA,CB,CC],32),
	period([DA,DB,DC,DD],16),
	period([EA,EB],16),
	period([FA,FB],32),
	period([GA,GB],32),
	period([HA,HB,HC,HD,HE,HF,HG,HH],16),
	period([IA,IB,IC,ID,IE,IF,IG,IH],16),
write(period),nl,	

	dotasks([AA,AB,AC,AD,AE,AF,AG,
		BA,BB,
		CA,CB,CC,
		DA,DB,DC,DD,
		EA,EB,
		FA,FB,
		GA,GB,
		HA,HB,HC,HD,HE,HF,HG,HH,
		IA,IB,IC,ID,IE,IF,IG,IH],
		End),
write(dotasks),nl,	
	
	message(AA,AB,Msgs,Msgs1),
	message(AA,AC,Msgs1,Msgs2),
	message(AB,AD,Msgs2,Msgs3),
	message(AB,AE,Msgs3,Msgs4),
	message(AB,AF,Msgs4,Msgs5),
	message(AC,AD,Msgs5,Msgs6),
	message(AE,AG,Msgs6,Msgs7),
	message(AF,AG,Msgs7,Msgs8),
	message(BA,BB,Msgs8,Msgs9),
	message(CA,CB,Msgs9,Msgs10),
	message(CB,CC,Msgs10,Msgs11),
	message(DA,DB,Msgs11,Msgs12),
	message(DA,DC,Msgs12,Msgs13),
	message(DB,DD,Msgs13,Msgs14),
	message(DC,DD,Msgs14,Msgs15),
	message(EA,EB,Msgs15,Msgs16),
	message(FA,FB,Msgs16,Msgs17),
	message(GA,GB,Msgs17,Msgs18),
	message(HA,HB,Msgs18,Msgs19),
	message(HA,HC,Msgs19,Msgs20),
	message(HB,HD,Msgs20,Msgs21),
	message(HC,HD,Msgs21,Msgs22),
	message(HD,HE,Msgs22,Msgs23),
	message(HE,HF,Msgs23,Msgs24),
	message(HE,HG,Msgs24,Msgs25),
	message(HF,HH,Msgs25,Msgs26),
	message(HG,HH,Msgs26,Msgs27),
	message(IA,IB,Msgs27,Msgs28),
	message(IA,IC,Msgs28,Msgs29),
	message(IB,ID,Msgs29,Msgs30),
	message(IC,ID,Msgs30,Msgs31),
	message(ID,IE,Msgs31,Msgs32),
	message(IE,IF,Msgs32,Msgs33),
	message(IE,IG,Msgs33,Msgs34),
	message(IF,IH,Msgs34,Msgs35),
	message(IG,IH,Msgs35,[]),
write(message),nl,	
	
	mart(AA,AD,62),
	mart(AA,AG,62),
	mart(BA,BB,26),
	mart(CA,CC,58),
	mart(DA,DD,38),
	mart(EA,EB,18),
	mart(FA,FB,18),
	mart(GA,GB,26),
	mart(HA,HH,17),
	mart(IA,IH,17),
	
	true.

task(task(Id,Maxt,Comp,Period,L,LP),Id,Maxt,Comp).

%period(L,P):- write(period(L,P)),nl,fail.
period([],_).
period([task(_,_,_,Period,_,_)|T],Period):- period(T,Period).

dotasks([],End).
dotasks([Task|T],End):- dotask(Task,End), dotasks(T,End).

dotask(task(_Id,Maxt,_Comp,Period,L,LP),End):-
	length(L,Maxt),
	L in 0..191,
	ordered(L),
	periodic(L,LP,Period,End).

periodic(L,L,Period,End):- End=<Period,!.
periodic(L,LP,Period,End):-
	plus(End1,Period,End),
	periodicl(L,LP,TP,End1),
	periodic(L,TP,Period,End1).


periodicl([],L,L,_).
periodicl([H|T],[H1|T1],T2,Distance):-
	pluslook(H,Distance,H1), %H #= H1+Distance
	periodicl(T,T1,T2,Distance).

message(task(_,_,Comp,_,Send,_), task(_,_,Comp,_,Recv,_), MsgLst, MsgLst) :-
	!,
	last(Send,LastSend),
	first(Recv,FirstRecv),
	LastSend#<FirstRecv.

message(task(_,_,Comp1,Period,Send,_), task(_,_,Comp2,Period,Recv,_), NewMsgLst,MsgLst):-
	Comp1\=Comp2,
	last(Send,LastSend),
	first(Recv,FirstRecv),
	[Msg] in 0..191,
	LastSend#<Msg,
	Msg#<FirstRecv,
	append(Msgs,MsgLst,NewMsgLst),
	periodic([Msg],Msgs,Period,128).

mart(task(_,_,_,Period,Stim,_),task(_,_,_,Period,Resp,_),Mart):-
	first(Stim,FirstStim),
	last(Stim,LastStim),
	last(Resp,LastResp),
	FirstStim+Mart#>LastResp,
	LastStim#<Period.

top(Tasks,Messages):-
	sched(Tasks,Messages,128),!.


sched(Tasks,Messages,End):-
	TaskVars in 0..191,
	Messages in 0..191,
	taskvars(Tasks,TaskVars),
	jobs(Tasks,Messages,End),
	comp(Tasks,8),
	alldifferent(Messages),
	append(Messages,TaskVars,Vars),
	labeling(Vars,[size,constraints,change]).

comp(Tasks,0):- !.
comp(Tasks,N):-
	plus(N1,1,N),
	collect(Tasks,N1,L),
	alldifferent(L),
	comp(Tasks,N1).

collect([],_,[]).
collect([task(_,_,Comp,_,_,L1)|T],Comp,L):-
	!,
	append(L1,T1,L),
	collect(T,Comp,T1).
collect([task(_,_,Comp1,_,_,L1)|T],Comp2,L):-
	Comp1\=Comp2,
	collect(T,Comp2,L).

delay taskvars(nonvar,any).
taskvars([],[]).
taskvars([task(_,_,_,_,_,L1)|T],L):-
	append(L1,T1,L),
	taskvars(T,T1).

ordered([]).
ordered([_]).
ordered([X,Y|T]):- X#<Y, ordered([Y|T]).
